ASMB
      HED <DELETE RESTORED ID SEGMENT>
      NAM IOF,7 Delete restored ID seg   ARW 790208 
      ENT IOF 
      EXT .ENTR,.XFER,EXEC,RMPAR
* 
*     FUNCTION IOF (NAME,IERR,LUMESS) 
* 
*     SCHEDULES PROGRAM "OF" TO DELETE ID SEGMENT OF RESTORED 
*     PROGRAM "NAME" FROM THE SYSTEM. 
*     A-REG RETURNS ERROR CODE IERR (=0 IF SUCCESSFUL, STANDARD 
*     FMGR ERROR CODES OTHERWISE).
*     ERROR MESSAGES ARE WRITTEN ON LUMESS (OR SYSTEM CONSOLE IF
*     LUMESS=0).  IF LUMESS<0, ALL ERROR MESSAGES ARE SUPPRESSED. 
*     NOTE:PROGRAM "OF" MUST HAVE A CURRENT ID SEGMENT AND
*          IS PREFERABLY INSTALLED AS A PERMANENT PROGRAM.
*          IF, FOR ANY REASON, PROGRAM OF IS NOT EXECUTABLE, IERR 
*          RETURNS =14 SO THAT CALLING PROGRAM IS AFFECTED IN A BENIGN
*          WAY IF PROGRAM RP IS NOT INSTALLED ON THE SYSTEM; NO ERROR 
*          MESSAGE IS PRINTED IN THIS CASE. 
* 
*     ARW 770523
* 
*     MODIFICATION RECORD:
*     WHEN   WHO  WHAT
*     780319 ARW  MODIFY TO PRINT ERROR MESSAGE ON ANY LU 
*     780612 ARW  RETURN WITH IERR=14 IF PROGRAM OF NOT EXECUTABLE
*     790208 ARW  MODIFY TO USE RMPAR FOR RTE-IV COMPATIBILITY
* 
NAME  BSS 1 
IERR  BSS 1 
MESS  BSS 1 
IOF   NOP 
      JSB .ENTR 
      DEF NAME
*     DO 100 I=1,3
*100  NAMX(I+1)=NAME(I) 
      LDA NAME
      LDB NAMXX 
      INB 
      JSB .XFER 
*     SCHEDULE PROGRAM "OF" 
*     CALL EXEC(100000B+23,IPROG,0,0,0,0,LUMESS,NAMX,-8)
      JSB EXEC
      DEF ERR 
      DEF CODE
      DEF PROG
      DEF ZERO
      DEF ZERO
      DEF ZERO
      DEF ZERO
      DEF MESS,I
NAMXX DEF NAMX
      DEF IBUFL 
*FOLLOWING INSTRUCTION EXECUTED ONLY IF ERROR IN EXEC(23,..) CALL 
ERR   JMP ERR14 
*     CALL RMPAR(IPAR)
*     IERR=IPAR 
*     IOF=IPAR
      JSB RMPAR 
      DEF *+2 
      DEF IPAR
      LDA IPAR
      STA IERR,I
      JMP IOF,I 
* 
*PROGRAM OF NOT EXECUTABLE. RETURN WITH IERR=14 
ERR14 LDA =D14
      STA IERR,I
      JMP IOF,I 
* 
PROG  ASC 3,OF
NAMX  ASC 4,,,
IBUFL DEC -8
IPAR  BSS 5 
ZERO  OCT 0 
CODE  OCT 100027
A     EQU 0 
B     EQU 1 
      END 
